Index: code/trunk/src/orxonox/CameraManager.cc
===================================================================
--- code/trunk/src/orxonox/CameraManager.cc	(revision 7266)
+++ code/trunk/src/orxonox/CameraManager.cc	(revision 7284)
@@ -34,9 +34,9 @@
 
 #include "util/StringUtils.h"
+#include "util/ScopedSingletonManager.h"
 #include "core/GameMode.h"
 #include "core/GraphicsManager.h"
 #include "core/GUIManager.h"
 #include "core/ObjectList.h"
-#include "core/ScopedSingletonManager.h"
 #include "tools/Shader.h"
 #include "graphics/Camera.h"
Index: code/trunk/src/orxonox/ChatHistory.cc
===================================================================
--- code/trunk/src/orxonox/ChatHistory.cc	(revision 7266)
+++ code/trunk/src/orxonox/ChatHistory.cc	(revision 7284)
@@ -28,5 +28,5 @@
 
 #include "ChatHistory.h"
-#include <core/ScopedSingletonManager.h>
+#include "util/ScopedSingletonManager.h"
 
 #ifndef CHATTEST
Index: code/trunk/src/orxonox/ChatInputHandler.cc
===================================================================
--- code/trunk/src/orxonox/ChatInputHandler.cc	(revision 7266)
+++ code/trunk/src/orxonox/ChatInputHandler.cc	(revision 7284)
@@ -28,9 +28,9 @@
 
 #include "ChatInputHandler.h"
-#include <core/ScopedSingletonManager.h>
-#include "core/ConsoleCommand.h"
+#include "util/ScopedSingletonManager.h"
 #include "core/CoreIncludes.h"
 #include "core/GUIManager.h"
 #include "core/CorePrereqs.h"
+#include "core/command/ConsoleCommand.h"
 #include <CEGUIWindow.h>
 #include <elements/CEGUIListbox.h>
@@ -46,8 +46,6 @@
 
   /* add commands to console */
-  SetConsoleCommandAlias( ChatInputHandler, activate_static, "startchat",
-    true );
-  SetConsoleCommandAlias( ChatInputHandler, activate_small_static,
-    "startchat_small", true );
+  SetConsoleCommand( "startchat", &ChatInputHandler::activate_static );
+  SetConsoleCommand( "startchat_small", &ChatInputHandler::activate_small_static );
 
   /* constructor */
Index: code/trunk/src/orxonox/LevelManager.cc
===================================================================
--- code/trunk/src/orxonox/LevelManager.cc	(revision 7266)
+++ code/trunk/src/orxonox/LevelManager.cc	(revision 7284)
@@ -31,4 +31,5 @@
 #include <map>
 
+#include "util/ScopedSingletonManager.h"
 #include "core/CommandLineParser.h"
 #include "core/ConfigValueIncludes.h"
@@ -36,5 +37,4 @@
 #include "core/Loader.h"
 #include "core/Resource.h"
-#include "core/ScopedSingletonManager.h"
 #include "PlayerManager.h"
 #include "Level.h"
Index: code/trunk/src/orxonox/MoodManager.cc
===================================================================
--- code/trunk/src/orxonox/MoodManager.cc	(revision 7266)
+++ code/trunk/src/orxonox/MoodManager.cc	(revision 7284)
@@ -29,7 +29,7 @@
 #include "MoodManager.h"
 
+#include "util/ScopedSingletonManager.h"
 #include "core/ConfigValueIncludes.h"
 #include "core/CoreIncludes.h"
-#include "core/ScopedSingletonManager.h"
 #include "core/Resource.h"
 
@@ -48,5 +48,5 @@
         // Need to use a variable to store old data because ResetConfigValues() doesn't seem to work.
         oldMood_ = MoodManager::defaultMood_;
-        
+
         // Checking for the existence of the folder for the default mood
         const std::string& path = "ambient/" + MoodManager::defaultMood_ + "/.";
Index: code/trunk/src/orxonox/OrxonoxPrecompiledHeaders.h
===================================================================
--- code/trunk/src/orxonox/OrxonoxPrecompiledHeaders.h	(revision 7266)
+++ code/trunk/src/orxonox/OrxonoxPrecompiledHeaders.h	(revision 7284)
@@ -89,5 +89,5 @@
 #include "network/synchronisable/Synchronisable.h" // 70
 #include "util/MultiType.h"    // 65
-#include "core/Executor.h"     // 55
+#include "core/command/Executor.h"     // 55
 //#include "core/XMLPort.h"     // 41
 
Index: code/trunk/src/orxonox/PlayerManager.cc
===================================================================
--- code/trunk/src/orxonox/PlayerManager.cc	(revision 7266)
+++ code/trunk/src/orxonox/PlayerManager.cc	(revision 7284)
@@ -29,7 +29,7 @@
 #include "PlayerManager.h"
 
+#include "util/ScopedSingletonManager.h"
 #include "core/CoreIncludes.h"
 #include "core/GameMode.h"
-#include "core/ScopedSingletonManager.h"
 #include "Level.h"
 #include "infos/HumanPlayer.h"
Index: code/trunk/src/orxonox/Radar.cc
===================================================================
--- code/trunk/src/orxonox/Radar.cc	(revision 7266)
+++ code/trunk/src/orxonox/Radar.cc	(revision 7284)
@@ -37,6 +37,6 @@
 
 //#include "util/Math.h"
-#include "core/ConsoleCommand.h"
 #include "core/ObjectList.h"
+#include "core/command/ConsoleCommand.h"
 #include "interfaces/RadarListener.h"
 #include "controllers/HumanController.h"
Index: code/trunk/src/orxonox/Test.cc
===================================================================
--- code/trunk/src/orxonox/Test.cc	(revision 7266)
+++ code/trunk/src/orxonox/Test.cc	(revision 7284)
@@ -29,5 +29,5 @@
 #include "core/CoreIncludes.h"
 #include "core/ConfigValueIncludes.h"
-#include "core/ConsoleCommand.h"
+#include "core/command/ConsoleCommand.h"
 #include "network/NetworkFunction.h"
 #include "Test.h"
@@ -37,21 +37,21 @@
 {
     CreateFactory ( Test );
-  
-    SetConsoleCommand(Test, printV1, true).accessLevel(AccessLevel::User);
-    SetConsoleCommand(Test, printV2, true).accessLevel(AccessLevel::User);
-    SetConsoleCommand(Test, printV3, true).accessLevel(AccessLevel::User);
-    SetConsoleCommand(Test, printV4, true).accessLevel(AccessLevel::User);
-    SetConsoleCommand(Test, call, true).accessLevel(AccessLevel::User);
-    SetConsoleCommand(Test, call2, true).accessLevel(AccessLevel::User);
-  
-  
+
+    SetConsoleCommand("Test", "printV1", &Test::printV1).addShortcut();
+    SetConsoleCommand("Test", "printV2", &Test::printV2).addShortcut();
+    SetConsoleCommand("Test", "printV3", &Test::printV3).addShortcut();
+    SetConsoleCommand("Test", "printV4", &Test::printV4).addShortcut();
+    SetConsoleCommand("Test", "call",    &Test::call).addShortcut();
+    SetConsoleCommand("Test", "call2",   &Test::call2).addShortcut();
+
+
   //void=* aaaaa = copyPtr<sizeof(&Test::printV1)>( &NETWORK_FUNCTION_POINTER, &Test::printV1 );
   //void* NETWORK_FUNCTION_TEST_B = memcpy(&NETWORK_FUNCTION_POINTER, &a, sizeof(a));
 //   NetworkFunctionBase* NETWORK_FUNCTION_TEST_C = new NetworkFunctionStatic( createFunctor(&Test::printV1), "bla", NETWORK_FUNCTION_POINTER );
-  
+
     registerStaticNetworkFunction( &Test::printV1 );
     registerMemberNetworkFunction( Test, checkU1 );
     registerMemberNetworkFunction( Test, printBlaBla );
-  
+
     Test* Test::instance_ = 0;
 
@@ -78,5 +78,5 @@
         SetConfigValue ( u3, 3 )/*.callback ( this, &Test::checkV3 )*/;
         SetConfigValue ( u4, 4 )/*.callback ( this, &Test::checkV4 )*/;
-    
+
         SetConfigValue ( s1, 1 )/*.callback ( this, &Test::checkV1 )*/;
         SetConfigValue ( s2, 2 )/*.callback ( this, &Test::checkV2 )*/;
@@ -89,18 +89,18 @@
     {
         registerVariable ( this->mySet_, VariableDirection::ToClient );
-      
+
 //         registerVariable ( u1, VariableDirection::ToClient, new NetworkCallback<Test> ( this, &Test::checkU1 ));
 //         registerVariable ( u2, VariableDirection::ToServer, new NetworkCallback<Test> ( this, &Test::checkU2 ));
 //         registerVariable ( u3, Bidirectionality::ServerMaster, new NetworkCallback<Test> ( this, &Test::checkU3 ), true );
 //         registerVariable ( u4, Bidirectionality::ClientMaster, new NetworkCallback<Test> ( this, &Test::checkU4 ), true );
-    
+
 //         registerVariable ( s1, VariableDirection::ToClient, new NetworkCallback<Test> ( this, &Test::checkS1 ));
 //         registerVariable ( s2, VariableDirection::ToServer, new NetworkCallback<Test> ( this, &Test::checkS2 ));
 //         registerVariable ( s3, Bidirectionality::ServerMaster, new NetworkCallback<Test> ( this, &Test::checkS3 ), true );
 //         registerVariable ( s4, Bidirectionality::ClientMaster, new NetworkCallback<Test> ( this, &Test::checkS4 ), true );
-    
+
 //         registerVariable ( pointer_, VariableDirection::ToClient, new NetworkCallback<Test> ( this, &Test::printPointer ) );
     }
-  
+
   void Test::call(unsigned int clientID)
     {
@@ -108,10 +108,10 @@
         callStaticNetworkFunction( &Test::printV1, clientID );
     }
-  
+
     void Test::call2(unsigned int clientID, std::string s1, std::string s2, std::string s3, std::string s4)
     {
         callMemberNetworkFunction( Test, printBlaBla, this->getObjectID(), clientID, s1, s2, s3, s4, s4 );
     }
-  
+
     void Test::tick(float dt)
     {
@@ -132,10 +132,10 @@
     //       callMemberNetworkFunction( Test, checkU1, this->getObjectID(), 0 );
     }
-    
+
     void Test::printBlaBla(std::string s1, std::string s2, std::string s3, std::string s4, std::string s5)
     {
         COUT(0) << s1 << s2 << s3 << s4 << s5 << endl;
     }
-    
+
     void Test::checkU1(){ COUT(1) << "U1 changed: " << u1 << std::endl; }
     void Test::checkU2(){ COUT(1) << "U2 changed: " << u2 << std::endl; }
@@ -147,5 +147,5 @@
     void Test::checkS3(){ COUT(1) << "S3 changed: " << s3 << std::endl; }
     void Test::checkS4(){ COUT(1) << "S4 changed: " << s4 << std::endl; }
-    
+
     void Test::printPointer(){ CCOUT(1) << "pointer: " << this->pointer_ << endl; }
 
Index: code/trunk/src/orxonox/controllers/AIController.cc
===================================================================
--- code/trunk/src/orxonox/controllers/AIController.cc	(revision 7266)
+++ code/trunk/src/orxonox/controllers/AIController.cc	(revision 7284)
@@ -31,5 +31,5 @@
 #include "util/Math.h"
 #include "core/CoreIncludes.h"
-#include "core/Executor.h"
+#include "core/command/Executor.h"
 #include "worldentities/ControllableEntity.h"
 #include "worldentities/pawns/Pawn.h"
Index: code/trunk/src/orxonox/controllers/ArtificialController.cc
===================================================================
--- code/trunk/src/orxonox/controllers/ArtificialController.cc	(revision 7266)
+++ code/trunk/src/orxonox/controllers/ArtificialController.cc	(revision 7284)
@@ -33,7 +33,7 @@
 
 #include "util/Math.h"
-#include "core/ConsoleCommand.h"
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
+#include "core/command/ConsoleCommand.h"
 #include "worldentities/ControllableEntity.h"
 #include "worldentities/pawns/Pawn.h"
@@ -47,9 +47,9 @@
 namespace orxonox
 {
-    SetConsoleCommand(ArtificialController, formationflight, true);
-    SetConsoleCommand(ArtificialController, masteraction, true);
-    SetConsoleCommand(ArtificialController, followme, true);
-    SetConsoleCommand(ArtificialController, passivebehaviour, true);
-    SetConsoleCommand(ArtificialController, formationsize, true);
+    SetConsoleCommand("ArtificialController", "formationflight",  &ArtificialController::formationflight);
+    SetConsoleCommand("ArtificialController", "masteraction",     &ArtificialController::masteraction);
+    SetConsoleCommand("ArtificialController", "followme",         &ArtificialController::followme);
+    SetConsoleCommand("ArtificialController", "passivebehaviour", &ArtificialController::passivebehaviour);
+    SetConsoleCommand("ArtificialController", "formationsize",    &ArtificialController::formationsize);
 
     static const unsigned int STANDARD_MAX_FORMATION_SIZE = 7;
Index: code/trunk/src/orxonox/controllers/DroneController.cc
===================================================================
--- code/trunk/src/orxonox/controllers/DroneController.cc	(revision 7266)
+++ code/trunk/src/orxonox/controllers/DroneController.cc	(revision 7284)
@@ -32,5 +32,5 @@
 
 #include "core/CoreIncludes.h"
-#include "core/Executor.h"
+#include "core/command/Executor.h"
 #include "worldentities/ControllableEntity.h"
 
Index: code/trunk/src/orxonox/controllers/HumanController.cc
===================================================================
--- code/trunk/src/orxonox/controllers/HumanController.cc	(revision 7266)
+++ code/trunk/src/orxonox/controllers/HumanController.cc	(revision 7284)
@@ -30,5 +30,5 @@
 
 #include "core/CoreIncludes.h"
-#include "core/ConsoleCommand.h"
+#include "core/command/ConsoleCommand.h"
 #include "worldentities/ControllableEntity.h"
 #include "worldentities/pawns/Pawn.h"
@@ -40,24 +40,24 @@
 namespace orxonox
 {
-    SetConsoleCommand(HumanController, moveFrontBack, true).setAsInputCommand();
-    SetConsoleCommand(HumanController, moveRightLeft, true).setAsInputCommand();
-    SetConsoleCommand(HumanController, moveUpDown,    true).setAsInputCommand();
-    SetConsoleCommand(HumanController, rotateYaw,     true).setAsInputCommand();
-    SetConsoleCommand(HumanController, rotatePitch,   true).setAsInputCommand();
-    SetConsoleCommand(HumanController, rotateRoll,    true).setAsInputCommand();
-    SetConsoleCommand(HumanController, fire,          true).keybindMode(KeybindMode::OnHold);
-    SetConsoleCommand(HumanController, reload,        true);
-    SetConsoleCommand(HumanController, boost,         true).keybindMode(KeybindMode::OnHold);
-    SetConsoleCommand(HumanController, greet,         true);
-    SetConsoleCommand(HumanController, switchCamera,  true);
-    SetConsoleCommand(HumanController, mouseLook,     true);
-    SetConsoleCommand(HumanController, suicide,       true);
-    SetConsoleCommand(HumanController, toggleGodMode, true);
-    SetConsoleCommand(HumanController, addBots,       true).defaultValues(1);
-    SetConsoleCommand(HumanController, killBots,      true).defaultValues(0);
-    SetConsoleCommand(HumanController, dropItems,     true);
-    SetConsoleCommand(HumanController, useItem,       true);
-    SetConsoleCommand(HumanController, cycleNavigationFocus,   true);
-    SetConsoleCommand(HumanController, releaseNavigationFocus, true);
+    SetConsoleCommand("HumanController", "moveFrontBack",          &HumanController::moveFrontBack ).addShortcut().setAsInputCommand();
+    SetConsoleCommand("HumanController", "moveRightLeft",          &HumanController::moveRightLeft ).addShortcut().setAsInputCommand();
+    SetConsoleCommand("HumanController", "moveUpDown",             &HumanController::moveUpDown    ).addShortcut().setAsInputCommand();
+    SetConsoleCommand("HumanController", "rotateYaw",              &HumanController::rotateYaw     ).addShortcut().setAsInputCommand();
+    SetConsoleCommand("HumanController", "rotatePitch",            &HumanController::rotatePitch   ).addShortcut().setAsInputCommand();
+    SetConsoleCommand("HumanController", "rotateRoll",             &HumanController::rotateRoll    ).addShortcut().setAsInputCommand();
+    SetConsoleCommand("HumanController", "fire",                   &HumanController::fire          ).addShortcut().keybindMode(KeybindMode::OnHold);
+    SetConsoleCommand("HumanController", "reload",                 &HumanController::reload        ).addShortcut();
+    SetConsoleCommand("HumanController", "boost",                  &HumanController::boost         ).addShortcut().keybindMode(KeybindMode::OnHold);
+    SetConsoleCommand("HumanController", "greet",                  &HumanController::greet         ).addShortcut();
+    SetConsoleCommand("HumanController", "switchCamera",           &HumanController::switchCamera  ).addShortcut();
+    SetConsoleCommand("HumanController", "mouseLook",              &HumanController::mouseLook     ).addShortcut();
+    SetConsoleCommand("HumanController", "suicide",                &HumanController::suicide       ).addShortcut();
+    SetConsoleCommand("HumanController", "toggleGodMode",          &HumanController::toggleGodMode ).addShortcut();
+    SetConsoleCommand("HumanController", "addBots",                &HumanController::addBots       ).addShortcut().defaultValues(1);
+    SetConsoleCommand("HumanController", "killBots",               &HumanController::killBots      ).addShortcut().defaultValues(0);
+    SetConsoleCommand("HumanController", "dropItems",              &HumanController::dropItems     ).addShortcut();
+    SetConsoleCommand("HumanController", "useItem",                &HumanController::useItem       ).addShortcut();
+    SetConsoleCommand("HumanController", "cycleNavigationFocus",   &HumanController::cycleNavigationFocus).addShortcut();
+    SetConsoleCommand("HumanController", "releaseNavigationFocus", &HumanController::releaseNavigationFocus).addShortcut();
 
     CreateUnloadableFactory(HumanController);
Index: code/trunk/src/orxonox/controllers/NewHumanController.cc
===================================================================
--- code/trunk/src/orxonox/controllers/NewHumanController.cc	(revision 7266)
+++ code/trunk/src/orxonox/controllers/NewHumanController.cc	(revision 7284)
@@ -37,5 +37,5 @@
 
 #include "core/CoreIncludes.h"
-#include "core/ConsoleCommand.h"
+#include "core/command/ConsoleCommand.h"
 #include "worldentities/ControllableEntity.h"
 #include "worldentities/pawns/Pawn.h"
@@ -49,8 +49,8 @@
 namespace orxonox
 {
-    SetConsoleCommand(NewHumanController, changeMode, false).keybindMode(KeybindMode::OnPress);
-    SetConsoleCommand(NewHumanController, accelerate, false).keybindMode(KeybindMode::OnPress);
-    SetConsoleCommand(NewHumanController, decelerate, false).keybindMode(KeybindMode::OnPress);
-    SetConsoleCommand(NewHumanController, unfire,      true).keybindMode(KeybindMode::OnRelease);
+    SetConsoleCommand("NewHumanController", "changeMode", &NewHumanController::changeMode).keybindMode(KeybindMode::OnPress);
+    SetConsoleCommand("NewHumanController", "accelerate", &NewHumanController::accelerate).keybindMode(KeybindMode::OnPress);
+    SetConsoleCommand("NewHumanController", "decelerate", &NewHumanController::decelerate).keybindMode(KeybindMode::OnPress);
+    SetConsoleCommand("NewHumanController", "unfire",     &NewHumanController::unfire    ).keybindMode(KeybindMode::OnRelease).addShortcut();
 
     CreateUnloadableFactory(NewHumanController);
Index: code/trunk/src/orxonox/gamestates/GSGraphics.cc
===================================================================
--- code/trunk/src/orxonox/gamestates/GSGraphics.cc	(revision 7266)
+++ code/trunk/src/orxonox/gamestates/GSGraphics.cc	(revision 7284)
@@ -35,8 +35,8 @@
 #include "GSGraphics.h"
 
-#include "core/CommandExecutor.h"
-#include "core/ConsoleCommand.h"
 #include "core/Game.h"
 #include "core/GUIManager.h"
+#include "core/command/ConsoleCommand.h"
+#include "core/command/CommandExecutor.h"
 
 namespace orxonox
Index: code/trunk/src/orxonox/gamestates/GSLevel.cc
===================================================================
--- code/trunk/src/orxonox/gamestates/GSLevel.cc	(revision 7266)
+++ code/trunk/src/orxonox/gamestates/GSLevel.cc	(revision 7284)
@@ -36,5 +36,4 @@
 #include "core/input/InputState.h"
 #include "core/input/KeyBinderManager.h"
-#include "core/ConsoleCommand.h"
 #include "core/Game.h"
 #include "core/GameMode.h"
@@ -42,4 +41,5 @@
 #include "core/Loader.h"
 #include "core/XMLFile.h"
+#include "core/command/ConsoleCommand.h"
 
 #include "LevelManager.h"
Index: code/trunk/src/orxonox/gamestates/GSMainMenu.cc
===================================================================
--- code/trunk/src/orxonox/gamestates/GSMainMenu.cc	(revision 7266)
+++ code/trunk/src/orxonox/gamestates/GSMainMenu.cc	(revision 7284)
@@ -33,9 +33,9 @@
 #include "core/input/KeyBinderManager.h"
 #include "core/Game.h"
-#include "core/ConsoleCommand.h"
 #include "core/ConfigValueIncludes.h"
 #include "core/CoreIncludes.h"
 #include "core/GraphicsManager.h"
 #include "core/GUIManager.h"
+#include "core/command/ConsoleCommand.h"
 #include "Scene.h"
 #include "sound/AmbientSound.h"
@@ -48,4 +48,18 @@
     DeclareGameState(GSMainMenu, "mainMenu", false, true);
 
+    static const std::string __CC_startStandalone_name      = "startGame";
+    static const std::string __CC_startServer_name          = "startServer";
+    static const std::string __CC_startClient_name          = "startClient";
+    static const std::string __CC_startDedicated_name       = "startDedicated";
+    static const std::string __CC_startMainMenu_name        = "startMainMenu";
+    static const std::string __CC_setMainMenuSoundPath_name = "setMMSoundPath";
+
+    SetConsoleCommand(__CC_startStandalone_name,      &GSMainMenu::startStandalone).deactivate();
+    SetConsoleCommand(__CC_startServer_name,          &GSMainMenu::startServer    ).deactivate();
+    SetConsoleCommand(__CC_startClient_name,          &GSMainMenu::startClient    ).deactivate();
+    SetConsoleCommand(__CC_startDedicated_name,       &GSMainMenu::startDedicated ).deactivate();
+    SetConsoleCommand(__CC_startMainMenu_name,        &GSMainMenu::startMainMenu  ).deactivate();
+    SetConsoleCommand(__CC_setMainMenuSoundPath_name, &GSMainMenu::setMainMenuSoundPath).hide();
+
     GSMainMenu::GSMainMenu(const GameStateInfo& info)
         : GameState(info)
@@ -89,12 +103,10 @@
         InputManager::getInstance().enterState("MainMenuHackery");
 
-        CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(createFunctor(&GSMainMenu::startStandalone), "startGame"));
-        CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(createFunctor(&GSMainMenu::startServer), "startServer"));
-        CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(createFunctor(&GSMainMenu::startClient), "startClient"));
-        CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(createFunctor(&GSMainMenu::startDedicated), "startDedicated"));
-        CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(createFunctor(&GSMainMenu::startMainMenu), "startMainMenu"));
-
-        // create command to change sound path
-        CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(createFunctor(&GSMainMenu::setMainMenuSoundPath, this), "setMMSoundPath"));
+        ModifyConsoleCommand(__CC_startStandalone_name).activate();
+        ModifyConsoleCommand(__CC_startServer_name    ).activate();
+        ModifyConsoleCommand(__CC_startClient_name    ).activate();
+        ModifyConsoleCommand(__CC_startDedicated_name ).activate();
+        ModifyConsoleCommand(__CC_startMainMenu_name  ).activate();
+        ModifyConsoleCommand(__CC_setMainMenuSoundPath_name).setObject(this);
 
         KeyBinderManager::getInstance().setToDefault();
@@ -122,4 +134,11 @@
         GUIManager::hideGUI("MainMenu");
         GraphicsManager::getInstance().setCamera(0);
+
+        ModifyConsoleCommand(__CC_startStandalone_name).deactivate();
+        ModifyConsoleCommand(__CC_startServer_name    ).deactivate();
+        ModifyConsoleCommand(__CC_startClient_name    ).deactivate();
+        ModifyConsoleCommand(__CC_startDedicated_name ).deactivate();
+        ModifyConsoleCommand(__CC_startMainMenu_name  ).deactivate();
+        ModifyConsoleCommand(__CC_setMainMenuSoundPath_name).setObject(0);
     }
 
Index: code/trunk/src/orxonox/gamestates/GSRoot.cc
===================================================================
--- code/trunk/src/orxonox/gamestates/GSRoot.cc	(revision 7266)
+++ code/trunk/src/orxonox/gamestates/GSRoot.cc	(revision 7284)
@@ -31,7 +31,7 @@
 #include "util/Clock.h"
 #include "core/BaseObject.h"
-#include "core/ConsoleCommand.h"
 #include "core/Game.h"
 #include "core/GameMode.h"
+#include "core/command/ConsoleCommand.h"
 #include "network/NetworkFunction.h"
 #include "tools/Timer.h"
@@ -41,5 +41,11 @@
 {
     DeclareGameState(GSRoot, "root", false, false);
-    SetConsoleCommandShortcut(GSRoot, printObjects);
+
+    static const std::string __CC_setTimeFactor_name = "setTimeFactor";
+    static const std::string __CC_pause_name = "pause";
+
+    SetConsoleCommand("printObjects", &GSRoot::printObjects).hide();
+    SetConsoleCommand(__CC_setTimeFactor_name, &GSRoot::setTimeFactor).accessLevel(AccessLevel::Master).defaultValues(1.0);
+    SetConsoleCommand(__CC_pause_name,         &GSRoot::pause        ).accessLevel(AccessLevel::Master);
 
     registerStaticNetworkFunction(&TimeFactorListener::setTimeFactor);
@@ -76,15 +82,12 @@
         TimeFactorListener::setTimeFactor(1.0f);
 
-        // time factor console command
-        ConsoleCommand* command = createConsoleCommand(createFunctor(&GSRoot::setTimeFactor, this), "setTimeFactor");
-        CommandExecutor::addConsoleCommandShortcut(command).accessLevel(AccessLevel::Offline).defaultValue(0, 1.0);
-
-        // time factor console command
-        command = createConsoleCommand(createFunctor(&GSRoot::pause, this), "pause");
-        CommandExecutor::addConsoleCommandShortcut(command).accessLevel(AccessLevel::Offline);
+        ModifyConsoleCommand(__CC_setTimeFactor_name).setObject(this);
+        ModifyConsoleCommand(__CC_pause_name).setObject(this);
     }
 
     void GSRoot::deactivate()
     {
+        ModifyConsoleCommand(__CC_setTimeFactor_name).setObject(0);
+        ModifyConsoleCommand(__CC_pause_name).setObject(0);
     }
 
Index: code/trunk/src/orxonox/gametypes/Dynamicmatch.cc
===================================================================
--- code/trunk/src/orxonox/gametypes/Dynamicmatch.cc	(revision 7266)
+++ code/trunk/src/orxonox/gametypes/Dynamicmatch.cc	(revision 7284)
@@ -155,5 +155,7 @@
                     spaceship->getEngine()->setSpeedFactor(5);
                     WeakPtr<Engine>* ptr = new WeakPtr<Engine>(spaceship->getEngine());
-                    new Timer(10, false, &createExecutor(createFunctor(&Dynamicmatch::resetSpeedFactor, this))->setDefaultValue(0, ptr), true);
+                    ExecutorPtr executor = createExecutor(createFunctor(&Dynamicmatch::resetSpeedFactor, this));
+                    executor->setDefaultValue(0, ptr);
+                    new Timer(10, false, executor, true);
                 }
             }
@@ -254,5 +256,7 @@
                     spaceship->getEngine()->setSpeedFactor(5);
                     WeakPtr<Engine>* ptr = new WeakPtr<Engine>(spaceship->getEngine());
-                    new Timer(10, false, &createExecutor(createFunctor(&Dynamicmatch::resetSpeedFactor, this))->setDefaultValue(0, ptr), true);
+                    ExecutorPtr executor = createExecutor(createFunctor(&Dynamicmatch::resetSpeedFactor, this));
+                    executor->setDefaultValue(0, ptr);
+                    new Timer(10, false, executor, true);
                 }
 
Index: code/trunk/src/orxonox/gametypes/Gametype.cc
===================================================================
--- code/trunk/src/orxonox/gametypes/Gametype.cc	(revision 7266)
+++ code/trunk/src/orxonox/gametypes/Gametype.cc	(revision 7284)
@@ -33,5 +33,5 @@
 #include "core/ConfigValueIncludes.h"
 #include "core/GameMode.h"
-#include "core/ConsoleCommand.h"
+#include "core/command/ConsoleCommand.h"
 
 #include "infos/PlayerInfo.h"
@@ -79,11 +79,4 @@
         else
             this->scoreboard_ = 0;
-
-        /* HACK HACK HACK */
-        this->hackAddBots_ = createConsoleCommand( createFunctor(&Gametype::addBots, this), "hackAddBots");
-        this->hackKillBots_ = createConsoleCommand( createFunctor(&Gametype::killBots, this), "hackKillBots");
-        CommandExecutor::addConsoleCommandShortcut( this->hackAddBots_ );
-        CommandExecutor::addConsoleCommandShortcut( this->hackKillBots_ );
-        /* HACK HACK HACK */
     }
 
@@ -93,8 +86,4 @@
         {
             this->gtinfo_->destroy();
-            if( this->hackAddBots_ )
-                delete this->hackAddBots_;
-            if( this->hackKillBots_ )
-                delete this->hackKillBots_;
         }
     }
Index: code/trunk/src/orxonox/gametypes/Gametype.h
===================================================================
--- code/trunk/src/orxonox/gametypes/Gametype.h	(revision 7266)
+++ code/trunk/src/orxonox/gametypes/Gametype.h	(revision 7284)
@@ -184,9 +184,4 @@
             // Config Values
             std::string scoreboardTemplate_;
-
-            /* HACK HACK HACK */
-            ConsoleCommand* hackAddBots_;
-            ConsoleCommand* hackKillBots_;
-            /* HACK HACK HACK */
     };
 }
Index: code/trunk/src/orxonox/gametypes/TeamBaseMatch.cc
===================================================================
--- code/trunk/src/orxonox/gametypes/TeamBaseMatch.cc	(revision 7266)
+++ code/trunk/src/orxonox/gametypes/TeamBaseMatch.cc	(revision 7284)
@@ -30,5 +30,5 @@
 
 #include "core/CoreIncludes.h"
-#include "core/Executor.h"
+#include "core/command/Executor.h"
 #include "worldentities/pawns/TeamBaseMatchBase.h"
 #include "infos/PlayerInfo.h"
Index: code/trunk/src/orxonox/graphics/ParticleSpawner.cc
===================================================================
--- code/trunk/src/orxonox/graphics/ParticleSpawner.cc	(revision 7266)
+++ code/trunk/src/orxonox/graphics/ParticleSpawner.cc	(revision 7284)
@@ -31,6 +31,6 @@
 #include "core/CoreIncludes.h"
 #include "core/EventIncludes.h"
-#include "core/Executor.h"
 #include "core/XMLPort.h"
+#include "core/command/Executor.h"
 #include "tools/ParticleInterface.h"
 
Index: code/trunk/src/orxonox/overlays/InGameConsole.cc
===================================================================
--- code/trunk/src/orxonox/overlays/InGameConsole.cc	(revision 7266)
+++ code/trunk/src/orxonox/overlays/InGameConsole.cc	(revision 7284)
@@ -45,8 +45,8 @@
 #include "util/Math.h"
 #include "util/DisplayStringConversions.h"
+#include "util/ScopedSingletonManager.h"
 #include "core/CoreIncludes.h"
 #include "core/ConfigValueIncludes.h"
-#include "core/ConsoleCommand.h"
-#include "core/ScopedSingletonManager.h"
+#include "core/command/ConsoleCommand.h"
 #include "core/input/InputManager.h"
 #include "core/input/InputState.h"
@@ -58,6 +58,6 @@
     const float CHAR_WIDTH = 7.45f; // fix this please - determine the char-width dynamically
 
-    SetConsoleCommand(InGameConsole, openConsole, true);
-    SetConsoleCommand(InGameConsole, closeConsole, true);
+    SetConsoleCommand("InGameConsole", "openConsole", &InGameConsole::openConsole).addShortcut();
+    SetConsoleCommand("InGameConsole", "closeConsole", &InGameConsole::closeConsole).addShortcut();
 
     ManageScopedSingleton(InGameConsole, ScopeID::Graphics, false);
Index: code/trunk/src/orxonox/overlays/InGameConsole.h
===================================================================
--- code/trunk/src/orxonox/overlays/InGameConsole.h	(revision 7266)
+++ code/trunk/src/orxonox/overlays/InGameConsole.h	(revision 7284)
@@ -37,6 +37,6 @@
 #include "util/OgreForwardRefs.h"
 #include "util/Singleton.h"
-#include "core/Shell.h"
 #include "core/WindowEventListener.h"
+#include "core/command/Shell.h"
 
 namespace orxonox
Index: code/trunk/src/orxonox/overlays/OrxonoxOverlay.cc
===================================================================
--- code/trunk/src/orxonox/overlays/OrxonoxOverlay.cc	(revision 7266)
+++ code/trunk/src/orxonox/overlays/OrxonoxOverlay.cc	(revision 7284)
@@ -48,5 +48,5 @@
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
-#include "core/ConsoleCommand.h"
+#include "core/command/ConsoleCommand.h"
 
 #include "OverlayGroup.h"
@@ -57,8 +57,8 @@
     std::map<std::string, OrxonoxOverlay*> OrxonoxOverlay::overlays_s;
 
-    SetConsoleCommand(OrxonoxOverlay, scaleOverlay, false).accessLevel(AccessLevel::User);
-    SetConsoleCommand(OrxonoxOverlay, scrollOverlay, false).accessLevel(AccessLevel::User);
-    SetConsoleCommand(OrxonoxOverlay, toggleVisibility, false).accessLevel(AccessLevel::User);
-    SetConsoleCommand(OrxonoxOverlay, rotateOverlay, false).accessLevel(AccessLevel::User);
+    SetConsoleCommand("OrxonoxOverlay", "scaleOverlay",     &OrxonoxOverlay::scaleOverlay);
+    SetConsoleCommand("OrxonoxOverlay", "scrollOverlay",    &OrxonoxOverlay::scrollOverlay);
+    SetConsoleCommand("OrxonoxOverlay", "toggleVisibility", &OrxonoxOverlay::toggleVisibility);
+    SetConsoleCommand("OrxonoxOverlay", "rotateOverlay",    &OrxonoxOverlay::rotateOverlay);
 
     OrxonoxOverlay::OrxonoxOverlay(BaseObject* creator)
Index: code/trunk/src/orxonox/overlays/OverlayGroup.cc
===================================================================
--- code/trunk/src/orxonox/overlays/OverlayGroup.cc	(revision 7266)
+++ code/trunk/src/orxonox/overlays/OverlayGroup.cc	(revision 7284)
@@ -34,7 +34,7 @@
 #include "OverlayGroup.h"
 
-#include "core/ConsoleCommand.h"
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
+#include "core/command/ConsoleCommand.h"
 #include "OrxonoxOverlay.h"
 
@@ -43,7 +43,7 @@
     CreateFactory(OverlayGroup);
 
-    SetConsoleCommand(OverlayGroup, toggleVisibility, false).accessLevel(AccessLevel::User);
-    SetConsoleCommand(OverlayGroup, scaleGroup, false).accessLevel(AccessLevel::User);
-    SetConsoleCommand(OverlayGroup, scrollGroup, false).accessLevel(AccessLevel::User);
+    SetConsoleCommand("OverlayGroup", "toggleVisibility", &OverlayGroup::toggleVisibility);
+    SetConsoleCommand("OverlayGroup", "scaleGroup",       &OverlayGroup::scaleGroup);
+    SetConsoleCommand("OverlayGroup", "scrollGroup",      &OverlayGroup::scrollGroup);
 
     OverlayGroup::OverlayGroup(BaseObject* creator)
Index: code/trunk/src/orxonox/sound/SoundManager.cc
===================================================================
--- code/trunk/src/orxonox/sound/SoundManager.cc	(revision 7266)
+++ code/trunk/src/orxonox/sound/SoundManager.cc	(revision 7284)
@@ -38,8 +38,8 @@
 #include "util/Math.h"
 #include "util/Clock.h"
+#include "util/ScopedSingletonManager.h"
 #include "core/ConfigValueIncludes.h"
 #include "core/CoreIncludes.h"
 #include "core/GameMode.h"
-#include "core/ScopedSingletonManager.h"
 #include "core/Resource.h"
 #include "SoundBuffer.h"
Index: code/trunk/src/orxonox/sound/WorldSound.cc
===================================================================
--- code/trunk/src/orxonox/sound/WorldSound.cc	(revision 7266)
+++ code/trunk/src/orxonox/sound/WorldSound.cc	(revision 7284)
@@ -37,5 +37,4 @@
 #include "Scene.h"
 #include "SoundManager.h"
-#include <core/ConsoleCommandCompilation.h>
 
 namespace orxonox
Index: code/trunk/src/orxonox/weaponsystem/Munition.cc
===================================================================
--- code/trunk/src/orxonox/weaponsystem/Munition.cc	(revision 7266)
+++ code/trunk/src/orxonox/weaponsystem/Munition.cc	(revision 7284)
@@ -461,5 +461,5 @@
         if (bUseReloadTime && (munition->reloadTime_ > 0 || munition->bStackMunition_))
         {
-            Executor* executor = createExecutor(createFunctor(&Magazine::loaded, this));
+            const ExecutorPtr& executor = createExecutor(createFunctor(&Magazine::loaded, this));
             executor->setDefaultValues(munition);
 
Index: code/trunk/src/orxonox/worldentities/BigExplosion.cc
===================================================================
--- code/trunk/src/orxonox/worldentities/BigExplosion.cc	(revision 7266)
+++ code/trunk/src/orxonox/worldentities/BigExplosion.cc	(revision 7284)
@@ -31,6 +31,6 @@
 #include "util/Exception.h"
 #include "core/CoreIncludes.h"
-#include "core/Executor.h"
 #include "core/GameMode.h"
+#include "core/command/Executor.h"
 #include "tools/ParticleInterface.h"
 #include "Scene.h"
Index: code/trunk/src/orxonox/worldentities/ExplosionChunk.cc
===================================================================
--- code/trunk/src/orxonox/worldentities/ExplosionChunk.cc	(revision 7266)
+++ code/trunk/src/orxonox/worldentities/ExplosionChunk.cc	(revision 7284)
@@ -30,6 +30,6 @@
 
 #include "core/CoreIncludes.h"
-#include "core/Executor.h"
 #include "core/GameMode.h"
+#include "core/command/Executor.h"
 #include "util/Exception.h"
 #include "Scene.h"
Index: code/trunk/src/orxonox/worldentities/MovableEntity.cc
===================================================================
--- code/trunk/src/orxonox/worldentities/MovableEntity.cc	(revision 7266)
+++ code/trunk/src/orxonox/worldentities/MovableEntity.cc	(revision 7284)
@@ -31,7 +31,7 @@
 
 #include "core/CoreIncludes.h"
-#include "core/Executor.h"
 #include "core/GameMode.h"
 #include "core/XMLPort.h"
+#include "core/command/Executor.h"
 #include "worldentities/pawns/Pawn.h"
 
